"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.x = exports.xpath2css = exports.isXPath = exports.parse = void 0;
const parser_1 = __importDefault(require("./parser"));
const to_selector_1 = __importDefault(require("./to-selector"));
exports.parse = (query) => new parser_1.default(query).parse();
exports.isXPath = (query) => {
    try {
        exports.parse(query);
        return true;
    }
    catch (e) {
        return false;
    }
};
exports.xpath2css = (query) => to_selector_1.default(exports.parse(query));
exports.default = exports.xpath2css;
exports.x = (arg, ...param) => {
    if (arg.length <= 1) {
        return exports.xpath2css(arg[0]);
    }
    let query = arg[0];
    for (let i = 1; i < arg.length; i++) {
        query += String(param[i - 1]);
        query += arg[i];
    }
    return exports.xpath2css(query);
};
