interface ttOptions {
    keyword?: string;
    beforeExpr?: boolean;
}
export declare class TokenType {
    label: string;
    beforeExpr: boolean;
    constructor(label: string, options?: ttOptions);
}
declare type keywordsMap = {
    [name: string]: TokenType;
};
export declare const keywords: keywordsMap;
declare const types: {
    num: TokenType;
    string: TokenType;
    name: TokenType;
    eof: TokenType;
    bracketL: TokenType;
    bracketR: TokenType;
    parenL: TokenType;
    parenR: TokenType;
    pipe: TokenType;
    slash: TokenType;
    doubleSlash: TokenType;
    star: TokenType;
    at: TokenType;
    eq: TokenType;
    comma: TokenType;
    and: TokenType;
};
export default types;
