"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.keywords = exports.TokenType = void 0;
class TokenType {
    constructor(label, options = {}) {
        this.label = label;
        this.beforeExpr = Boolean(options.beforeExpr);
    }
}
exports.TokenType = TokenType;
exports.keywords = {};
function kw(name, options = {}) {
    options.keyword = name;
    const tt = new TokenType(name, options);
    exports.keywords[name] = tt;
    return tt;
}
const types = {
    num: new TokenType("num"),
    string: new TokenType("string"),
    name: new TokenType("name"),
    eof: new TokenType("eof"),
    // Operators
    bracketL: new TokenType("["),
    bracketR: new TokenType("]"),
    parenL: new TokenType("("),
    parenR: new TokenType(")"),
    pipe: new TokenType("|"),
    slash: new TokenType("/"),
    doubleSlash: new TokenType("//"),
    star: new TokenType("*"),
    at: new TokenType("@"),
    eq: new TokenType("="),
    comma: new TokenType(","),
    and: kw("and", { beforeExpr: true }),
};
exports.default = types;
